$fn = 100;

syringe_cut_shift = -7*0;

bb3_do = 10 + 0.3;
bb3_h = 4;

bb6_do = 19 + 0.3;
bb6_h = 6;

// Cartridge mount
cm_wall = 10;

cm_X1 = -5;
cm_Y1 = 10;
cm_Z1 = 25;

cm_X2 = -5;
cm_Y2 = -10;
cm_Z2 = 25;

cm_X3 = -5;
cm_Y3 = -25;
cm_Z3 = 105;

cm_X4 = -5;
cm_Y4 = 25;
cm_Z4 = 105;

M3_hole = 3.5;
M3_nut_e = 6.3;
M6_hole = 6.5;
M6_nut_e = 11.05 + 0.3;

thread_d = 3;
thread_no = 2.0;
thread_h = 15 * thread_no / 3;
thread_no2 = 4.5;
thread_h2 = thread_h*thread_no2/thread_no;
thread_edge = 2;
tolerance = 1.0;


translate([65, 0, 30]){
//  cube(size=[43,43,40], center=true);
}

if(1==0){
  rotate([0, -90, 0])translate([-syringe_cut_shift, 0, 0]){
    difference(){
      union(){
        syringe_cartridge_100ml();
        translate([0, 0, 10])rotate([0, 90, 0]){
          roundedRect([20, 60, 0.35],5);
        }
      }
      translate([syringe_cut_shift-300, 0, 0]){
        cube(size=[600+0.1, 600, 600], center=true);
      }
    }
  }
}

if(1==0){
  rotate([0, 90, 180])translate([-syringe_cut_shift, 71, 0]){
    difference(){
      union(){
        syringe_cartridge_100ml();
        translate([0, 0, 10])rotate([0, -90, 0]){
          roundedRect([20, 60, 0.35],5);
        }
      }
      translate([syringe_cut_shift+300, 0, 0]){
        cube(size=[600+0.1, 600, 600], center=true);
      }
      translate([0, 0, 377.5]){
//        cube(size=[600+0.1, 600, 600], center=true);
      }
      translate([0, 0, -295.5]){
//        cube(size=[600+0.1, 600, 600], center=true);
      }
      
      for(i=[0:1:1])mirror([0,i,0])
      translate([0, 329.5-5, 0]){
//        cube(size=[600, 600, 600], center=true);
      }

    }
  }
}

//syringe_cartridge_20ml();
difference(){
//  syringe_cartridge_100ml();
  translate([0, 0, 237-330]){
//    cube(size=[200,200,200], center=true);
  }
}

//for(i=[0:1:1])mirror([0,i,0])
//translate([syringe_cut_shift, 10, 30*0]){
//  cartridge_holder();
//}
//translate([0, 70, 0])
//cartridge_holder_bar();

//translate([0, 0, 207])rotate([0, 0, 0]){
//  piston_hook();
//}

translate([45, 0, 87]){
//  cartridge_gear();
}
//translate([45, 0, 260]){
//  top_gear();
//}
translate([0, 0, 260]){
//  top_gear();
}

//translate([40, 0, 67])
//  stepper_gear();

insert_20ml();
//hook_20ml();

//translate([105, 0, 30])rotate([0, -90, 0])
//extruder_motor();
difference(){
  translate([0, 0, -3*0]){
//    cap();
  }
  translate([0, 0, 237-330]){
//    cube(size=[200,200,200], center=true);
  }
}


module hook_20ml(){
  h_d1 = 41;
  h_d2 = 38;
  h_h = 45;
  h_shift = 6;
  h_cut = 5;
  h_edge = 5;
  
  screw_depth = 30;
  syringe_d = 25;
  
  difference(){
    hull(){
      translate([0, 0, -h_edge/2])
      cylinder(d=h_d1, h=h_h-h_edge, center=true);
      translate([0, 0, h_h/2])
      cylinder(d=h_d2, h=0.1, center=true);
    }
    translate([h_shift, 0, (h_h-h_cut)/2+0.1]){
      cylinder(d=syringe_d, h=h_cut, center=true);
    }
  }
  
}

module insert_20ml(){
  i_do = 44-3.2;
  i_di = 22.5;
  i_h = 87;
  i_wall = 2;
  i_shift = 6;
  brim_h = 0.35;
  brim_d = 10;
  
  difference(){
    union(){
      intersection(){
        union(){
          translate([i_shift, 0, 0]){
            cylinder(d=i_di+2*i_wall, h=i_h, center=true);
          }
          rotate([0, 0, 45]){
            cube(size=[i_do, i_wall, i_h], center=true);
            cube(size=[i_wall, i_do, i_h], center=true);
          }
        }
        cylinder(d=i_do, h = i_h, center=true);
      }
      translate([0, 0, (brim_h-i_h)/2]){
        difference(){
          cylinder(d=i_do, h=brim_h, center=true);
          cylinder(d=i_do-brim_d, h=brim_h*1.1, center=true);
        }
      }
    }
    translate([i_shift, 0, 0]){
      cylinder(d=i_di, h=i_h*1.1, center=true);
    }
  }

}

module cartridge_holder_bar(){
  chb_w = 10;
  chb_h = 10;
  chb_l = 200;
  
  difference(){
    hull(){
      translate([chb_l/2, 0, chb_w/2]){
        cylinder(d=chb_h, h=chb_w, center=true);
      }
      translate([-chb_l/2, 0, chb_w/2]){
        cylinder(d=chb_h, h=chb_w, center=true);
      }
    }
    translate([-chb_l/2, 0, chb_w/2]){
      cylinder(d=M3_hole, h = chb_w*1.1, center=true);
    }
    translate([40-chb_l/2, 0, chb_w/2]){
      cylinder(d=M3_hole, h = chb_w*1.1, center=true);
    }

    for(i=[0:10:70])
    translate([chb_l/2-3 - i, 0, chb_w/2])rotate([90, 0, 0]){
      cylinder(d=M3_hole, h = chb_w*1.1, center=true);
    }

  }
}

module cartridge_holder(){
  ch_h1 = 10;
  ch_h2 = cm_Z4 - cm_Z2 + ch_h1 + 20;
  ch_wall = 2;
  ch_wall2 = 5;
  ch_w = 15;
  ch_l = 55;
  ch_gap = 25;
  
  for(i=[0:1:1])translate([0, 0, i * (cm_Z4 - cm_Z2)]){
    difference(){
      union(){
        roundedRect([ch_l, ch_w, ch_h1], 5, [1,1,0,0]);
        if(i==1){
          hull(){
            roundedRect([ch_l, ch_w, 0.1], 5, [1,1,0,0]);
            translate([0, ch_w/2, -ch_h1]){
              cube(size=[ch_l,0.1,0.1], center=true);
            }
          }
        }
      }
      hull(){
        translate([0, 0, ch_wall + M3_hole/2])rotate([0, 90, 0]){
          cylinder(d=M3_hole, h = 45, center=true);
        }
        translate([0, 0, ch_h1]){
          cube(size=[50, 10, 0.1], center=true);
        }
      }
      translate([0, 0, ch_h1/2]){
        cube(size=[ch_gap, ch_w*1.1, ch_h1*3.1], center=true);
      }
    }
  }
  // Mount wall
  translate([0, ch_w/2 + ch_wall2, ch_h2/2]){
    difference(){
      rotate([90, 0, 0]){
        roundedRect([ch_l, ch_h2, ch_wall2], 5, [0,0,1,1]);
      }
      translate([20, 0, ch_h2/2 - 5])rotate([90, 0, 0]){
        cylinder(d=M3_hole, h = ch_wall2*2.1, center=true);
      }
      translate([-20, 0, ch_h2/2 - 5])rotate([90, 0, 0]){
        cylinder(d=M3_hole, h = ch_wall2*2.1, center=true);
      }
    }
  }
  // Brim
  difference(){
    roundedRect([ch_l + 30, ch_w + 40, 0.35], 5);
    cube(size=[ch_gap, ch_w*2.1, ch_h1*3.1], center=true);
  }
}


module stepper_gear(){
  shaft_di = 5.2;
  shaft_do = 20;
  shaft_h = 7;
  gear_h1 = 10;
  gear_h2 = 7;

  translate([0, 0, gear_h1+gear_h2+shaft_h/2]){
    difference(){
      cylinder(d=shaft_do, h=shaft_h, center=true);
      cylinder(d=shaft_di, h=shaft_h*1.1, center=true);
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=shaft_do*1.1, center=true);
      }
      rotate([0, 0, 90])translate([6, 0, 0])rotate([0, 90, 0]){
        hull(){
          cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
          translate([-10,0,0]){
            cylinder(d=M3_nut_e, h=4, center=true, $fn=6);
          }
        }
      }
    }
  }  
  
  translate([0, 0, gear_h1])mirror([0,0,1]){
    gear(teeth = 17,h = gear_h1, shaft=shaft_di, extrude_scale=.8);
  }
  translate([0, 0, gear_h1]){
    gear(teeth = 17,h = gear_h2, shaft=shaft_di, extrude_scale=1);
  }
}

module cartridge_gear(){
  translate([0, 0, 2])mirror([0,0,1]){
    gear(teeth = 37,h = 2, shaft=M6_hole, extrude_scale=.955);
  }
  translate([0, 0, 2]){
    gear(teeth = 37,h = 5, shaft=M6_hole, extrude_scale=1);
  }
}

module top_gear(){
  translate([0, 0, 2])mirror([0,0,1]){
    gear(teeth = 43,h = 2, shaft=M6_hole, extrude_scale=.955);
  }
  translate([0, 0, 2]){
    gear(teeth = 43,h = 5, shaft=M6_hole, extrude_scale=1);
  }
}

module extruder_motor(){
  em_h = 60;
  em_w1 = 66;
  em_w2 = 66;
  em_l2 = 60;
  em_wall = 2;
  em_wall_2 = 20;
  
  // Stepper mount
  sm_w = 75;
  
  // Stepper dimensions
  s_screw_dis = 31;
  s_shift = 20;
  s_d1 = 22.5;
  s_edge = 38;
  
  difference(){
    union(){
      // Rear plate
      roundedRect([em_h, em_w2, em_wall], 5);
      // Stepper mount plate
      translate([em_h/2-em_wall*2, 0, sm_w/2])rotate([0, 90, 0]){
        roundedRect([sm_w, em_w1, em_wall_2], 5, [1,0,1,0]);
      }
      // Bottom mount plate
      hull(){
        translate([(em_wall-em_h)/2, (em_wall-em_w1)/2, em_l2/2]){
          cube(size=[em_wall, em_wall, em_l2], center=true);
        }
        translate([(em_wall-em_h)/2, -(em_wall-em_w1)/2, em_l2/2]){
          cube(size=[em_wall, em_wall, em_l2], center=true);
        }
        translate([(em_wall-em_h)/2, cm_Y1, sm_w])
        rotate([0, 90, 0]){
          cylinder(d=5, h = em_wall, center=true);
        }
        translate([(em_wall-em_h)/2, cm_Y2, sm_w])
        rotate([0, 90, 0]){
          cylinder(d=5, h = em_wall, center=true);
        }
      }
      
      // Side walls
      for(i=[0:1:1])mirror([0,i,0])
      hull(){
        translate([(em_wall-em_h)/2, (em_w1-em_wall)/2, em_l2/2]){
          cube(size=[1, em_wall, em_l2], center=true);
        }
        translate([(em_h-em_wall)/2, (em_w1-em_wall)/2, sm_w-16]){
          cube(size=[1, em_wall, 1], center=true);
        }
        translate([(em_h-em_wall)/2, (em_w1-em_wall)/2, em_wall/2]){
          cube(size=[1, em_wall, 1], center=true);
        }
      }
    }
    
    // Stepper mount points
    translate([em_h/2, 0, s_edge]){
      for(j=[0:1:1])mirror([0,0,j])
      for(i=[0:1:1])mirror([0,i,0]){
      translate([0, s_screw_dis/2, s_screw_dis/2])
        hull(){
          rotate([0, 90, 0]){
            translate([s_shift/2, 0, 0])
            cylinder(d=M3_hole, h=em_wall_2*4.1, center=true);
            translate([-s_shift/2, 0, 0])
            cylinder(d=M3_hole, h=em_wall_2*4.1, center=true);
          }
        }
      }
    }
    hull(){
      translate([em_h/2-em_wall*1.5, 0, s_edge-s_shift/2])
      rotate([0, 90, 0]){
        cylinder(d=s_d1, h=em_wall+0.1, center=true);
      }
      translate([em_h/2-em_wall*1.5, 0, s_edge+s_shift/2])
      rotate([0, 90, 0]){
        cylinder(d=s_d1, h=em_wall+0.1, center=true);
      }
    }
    hull(){
      translate([em_h/2, 0, s_edge-s_shift/2])
      rotate([0, 90, 0]){
        cylinder(d=7, h=em_wall_2*4.1, center=true);
      }
      translate([em_h/2, 0, s_edge+s_shift/2+15])
      rotate([0, 90, 0]){
        cylinder(d=7, h=em_wall_2*4.1, center=true);
      }
    }
    
    // Side walls cut
    translate([0, 0, em_l2/2])rotate([90, 30, 0]){
      cylinder(d = 35, h = em_w2*1.1, center=true, $fn=6);
    }
    
    // Top cut
      translate([em_h/2+em_wall, 0, sm_w/2])rotate([0, 90, 0]){
        roundedRect([sm_w+20, em_w1-25, em_wall_2], 5, [1,0,1,0]);
      }
      hull(){
        translate([em_h/2-em_wall*2+em_wall_2, 0, 60]){
          cube(size=[0.1, em_w1*1.1, 0.1], center=true);
        }
        translate([em_h/2+em_wall, 0, 0]){
          cube(size=[0.1, em_w1*1.1, 0.1], center=true);
        }
        translate([em_h/2+100, 0, 0]){
          cube(size=[0.1, em_w1*1.1, 0.1], center=true);
        }
      }
    
    
    // Cartridge mount points
    translate([-em_h/2, cm_Y1, 70])rotate([0, 90, 0]){
      cylinder(d=M3_hole, h=em_wall_2*2.1, center=true);
    }
    translate([-em_h/2, cm_Y2, 70])rotate([0, 90, 0]){
      cylinder(d=M3_hole, h=em_wall_2*2.1, center=true);
    }
    translate([em_h/2, cm_Y3, 70])rotate([0, 90, 0]){
      cylinder(d=M3_hole, h=em_wall_2*4.1, center=true);
    }
    translate([em_h/2, cm_Y4, 70])rotate([0, 90, 0]){
      cylinder(d=M3_hole, h=em_wall_2*4.1, center=true);
    }
    
    // Mount points on CR10
    translate([20, 20, 0]){
      cylinder(d=6, h=em_wall_2*2.1, center=true);
    }
    translate([20, -20, 0]){
      cylinder(d=6, h=em_wall_2*2.1, center=true);
    }
    translate([-20, 0, 0]){
      cylinder(d=6, h=em_wall_2*2.1, center=true);
    }
    hull(){
      translate([7, -25, 0]){
        cylinder(d=10, h=em_wall_2*2.1, center=true);
      }
      translate([7, -5, 0]){
        cylinder(d=10, h=em_wall_2*2.1, center=true);
      }
    }
    
  }
  
}


module piston_hook(){
  ph_h1 = 15;
  ph_w = 18;
  ph_edge = 8;
  ph_l = 105;
  
  translate([0, 0, ph_h1/2]){
    difference(){
      union(){
        intersection(){
          cube(size=[ph_l, ph_w, ph_h1], center=true);
          rotate([0, 90, 0]){
            cylinder(d=ph_w, h = ph_l, center=true);
          }
        }
        hull(){
          cylinder(d=42, h = 2, center=true);
          cylinder(d=33, h = ph_h1, center=true);
        }
        for(i=[0:1:1])mirror([i,0,0])
        translate([ph_l/2-ph_edge, 0, 0]){
          hull(){
            cylinder(d=25, h=ph_h1, center=true);
            translate([-10, 0, 0]){
              cylinder(d=25, h=ph_h1, center=true);
            }
          }
        }
      }
      for(i=[0:1:1])mirror([i,0,0])
      translate([ph_l/2-ph_edge, 0, ph_h1-5]){
        hull(){
          translate([-2.5*i, 0, 0])
          cylinder(d=M6_nut_e, h=ph_h1, center=true, $fn=6);
          translate([2.5*i, 0, 0])
          cylinder(d=M6_nut_e, h=ph_h1, center=true, $fn=6);
        }
        hull(){
          translate([-2.5*i, 0, 0])
          cylinder(d=M6_hole, h=ph_h1*4, center=true);
          translate([2.5*i, 0, 0])
          cylinder(d=M6_hole, h=ph_h1*4, center=true);
        }
      }
      for(i=[0:1:1])mirror([i,0,0]){
        translate([20, 0, 0]){
          cylinder(d=M3_hole, h=ph_h1*1.1, center=true);
          translate([0, 0, -ph_h1/2]){
            hull(){
              cylinder(d=M3_hole, h=12, center=true);
              cylinder(d=M3_nut_e, h=6, center=true, $fn=6);
            }
          }
        }
      }
    }
  }
  
}

module piston_hook_old(){
  ph_h1 = 27;
  ph_h2 = 15;
  ph_w = 9;
  ph_wall = 12;
  ph_shift = 40;
  ph_d = 25.5;
  ph_edge = 8;
  ph_l = ph_shift + ph_edge + ph_d/2 + 5;
  
  translate([0, 0, ph_h1/2]){
    difference(){
      union(){
        cube(size=[ph_l, ph_w, ph_h1], center=true);
        translate([ph_l/2-ph_edge, 0, 0]){
          cylinder(d=20, h=ph_h1, center=true);
        }
      }
      translate([ph_l/2-ph_edge, 0, 2]){
        cylinder(d=M6_nut_e, h=ph_h1, center=true, $fn=6);
        cylinder(d=M6_hole, h=ph_h1*2, center=true);
      }
      translate([ph_l/2-ph_edge-ph_shift, 0, ph_wall]){
        cylinder(d=ph_d, h=ph_h1, center=true);
      }
      translate([-ph_l/2, 0, ph_h1/2]){
        cube(size=[ph_l/4, ph_w*1.1, (ph_h1-ph_h2)*2], center=true);
      }
    }
  }
  
}


module syringe_cartridge_100ml(){
  // Syringe dimensions
  s_d1 = 44; // Max diameter syringe
  s_d2 = 10.5;  // Diameter syringe tip
  s_d4 = 17; // Top plate piston
  s_tip_shift = 6*0;
  s_h1 = 130; // Height main cylinder
  s_h2 = 115; // Height of pulled out piston

  // Threaded rod mount dimensions
  sr_X = 45;
  sr_w = 15;
  sr_wall = 10;
  
  // Syringe cartridge dimensions
  sc_wall = 2;
  sc_d3 = s_d1 + 2 * sc_wall;
  sc_h1 = s_h1 + s_h2 + 2 * sc_wall + 7;
  sc_h2 = 119; // Piston hub cut
  sc_thread_gap = 30;
  
  // Mount halfes
  mh_shift = syringe_cut_shift;
  mh_h = 10;
  mh_w1 = 40;
  mh_w2 = 30;
  mh_w3 = 10;
  mh_wall = 2;
  mh_l1 = sc_d3 + 10;
  mh_l2 = mh_l1 - 2 * mh_wall;
  mh_Z1 = 40;
  mh_Z_plus = 90;
  
  translate([0, 0, sc_h1/2]){
    difference(){
      union(){
        cylinder(d=sc_d3, h = sc_h1, center=true);
        translate([0, 0, thread_h - 5 - sc_h1/2]){
          helix_extrude(angle=360*thread_no, height=thread_h) {
            translate([sc_d3/2 - thread_d * 0.2, 0, 0]) {
                circle(d=3);
            }
          }
        }
        for(i=[0:1:1])mirror([i,0,0]){
          translate([0, 0, (cm_wall-sc_h1)/2 + cm_Z1]){
            hull(){
              cylinder(d=sc_d3, h = cm_wall, center=true);
  //            translate([sr_X, 0, 0]){
  //              cylinder(d=sr_w, h = sr_wall, center=true);
  //            }
              translate([sr_X + cm_X1, cm_Y1, 0]){
                cylinder(d=9, h = cm_wall, center=true);
              }
              translate([sr_X + cm_X2, cm_Y2, 0]){
                cylinder(d=9, h = cm_wall, center=true);
              }
            }
          }
          translate([0, 0, cm_Z3 - sc_h1/2]){
            hull(){
              translate([0, 0, 0]){
                cylinder(d=sc_d3, h = cm_wall, center=true);
              }
              translate([sr_X, 0, 0]){
                cylinder(d=bb6_do+4, h = cm_wall, center=true);
              }
              translate([sr_X + cm_X3, cm_Y3, 0]){
                cylinder(d=sr_w, h = cm_wall, center=true);
              }
              translate([sr_X + cm_X4, cm_Y4, 0]){
                cylinder(d=sr_w, h = cm_wall, center=true);
              }
            }
          }
          translate([0, 0, (-sr_wall*1-sc_h1)/2 + sc_h1]){
            hull(){
              cylinder(d=37, h = sr_wall, center=true);
              translate([sr_X, 0, 0]){
                cylinder(d=bb6_do+4, h = cm_wall, center=true);
              }
              translate([sr_X, sc_thread_gap/2, 0]){
                cylinder(d=sr_w, h = sr_wall, center=true);
              }
              translate([sr_X, -sc_thread_gap/2, 0]){
                cylinder(d=sr_w, h = sr_wall, center=true);
              }
            }
          }
          // Side walls threaded rod
          translate([sr_X/2, sc_thread_gap/2, sc_h1/2 - (sc_h1-cm_Z3)/2]){
            cube(size=[sr_X+8, sc_wall, (sc_h1-cm_Z3)], center=true);
          }
          translate([sr_X/2, -sc_thread_gap/2, sc_h1/2 - (sc_h1-cm_Z3)/2]){
            cube(size=[sr_X+8, sc_wall, (sc_h1-cm_Z3)], center=true);
          }

        }
        // Mount points halfes
        for(j=[0:1:2]){
          translate([mh_shift, 0, mh_Z1 - sc_h1/2 + j * mh_Z_plus]){
            difference(){
              hull(){
                translate([0, mh_l1/2, 0])rotate([0, 90, 0]){
                  cylinder(d=mh_h, h = mh_h, center=true);
                }
                translate([0, -mh_l1/2, 0])rotate([0, 90, 0]){
                  cylinder(d=mh_h, h = mh_h, center=true);
                }
//                cube(size=[mh_h, mh_l1, 10], center=true);
              }
              for(i=[0:1:1])mirror([0,i,0])
              translate([0, mh_l1/2, 0])rotate([0, 90, 0]){
                cylinder(d=3, h=mh_l1, center=true);
                translate([0, 0, mh_h/2]){
                  cylinder(d=M3_nut_e, h=5, center=true, $fn=6);
                }
                translate([0, 0, -mh_h/2]){
//                  cylinder(d=6, h=6, center=true);
                }
              }
            }
//            for(i=[0:1:1])mirror([0,i,0]){
//              translate([0, (mh_l1+mh_wall)/2, 0]){
//                hull(){
//                  cube(size=[mh_w2, mh_wall, mh_h], center=true);
//                  translate([0, 0, mh_h/2 - 0.5]){
//                    cube(size=[mh_w1, mh_wall*3, 1], center=true);
//                  }
//                }
//              }
//            }
          }
        }
      }

      for(i=[0:1:1])mirror([i,0,0]){      
        // Cartridge mount points
        translate([sr_X + cm_X1, cm_Y1, cm_Z1 - sc_h1/2]){
          hull(){
            cylinder(d=5, h = 0.1, center=true);
            translate([0, 0, cm_wall*0.75]){
              cylinder(d=M3_hole, h = 0.1, center=true);
            }
          }
          translate([0, 0, cm_wall/2]){
            cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
          }
        }

        translate([sr_X + cm_X2, cm_Y2, cm_Z2 - sc_h1/2]){
          hull(){
            cylinder(d=5, h = 0.1, center=true);
            translate([0, 0, cm_wall*0.75]){
              cylinder(d=M3_hole, h = 0.1, center=true);
            }
          }
          translate([0, 0, cm_wall/2]){
            cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
          }
        }

        translate([sr_X + cm_X3, cm_Y3, cm_Z3 - (sc_h1 + cm_wall)/2]){
          hull(){
            cylinder(d=5, h = 0.1, center=true);
            translate([0, 0, cm_wall*0.75]){
              cylinder(d=M3_hole, h = 0.1, center=true);
            }
          }
          translate([0, 0, cm_wall/2]){
            cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
          }
        }

        translate([sr_X + cm_X4, cm_Y4, cm_Z4 - (sc_h1 + cm_wall)/2]){
          hull(){
            cylinder(d=5, h = 0.1, center=true);
            translate([0, 0, cm_wall*0.75]){
              cylinder(d=M3_hole, h = 0.1, center=true);
            }
          }
          translate([0, 0, cm_wall/2]){
            cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
          }
        }

        // Threaded rod cut
        translate([sr_X, 0, 0]){
          cylinder(d=bb6_do-6, h = 80, center=true);
        }      
        translate([sr_X, 0, 100]){
          cylinder(d=M6_hole, h = 80, center=true);
        }      
        
        // Bottom ball bearing
  //      translate([sr_X, 0, sr_wall-(bb6_h + sc_h1)/2 + 0.1]){
  //        cylinder(d=bb6_do, h = bb6_h, center=true);
  //      }
        // Bottom ball bearing
        translate([sr_X, 0, cm_Z3 - (sc_h1 + cm_wall - bb6_h)/2 - 0.1]){
          cylinder(d=bb6_do, h = bb6_h, center=true);
        }
        // Middle ball bearing
        translate([sr_X, 0, cm_Z3 - (bb6_h + sc_h1 - cm_wall)/2 + 0.1]){
  //        cylinder(d=bb6_do, h = bb6_h, center=true);
        }
        // Top ball bearing
        translate([sr_X, 0, sc_h1/2]){
          cylinder(d=bb6_do, h = 6, center=true);
        }

        // Top gear mount hole
        translate([0, 0, sc_h1/2]){
          cylinder(d=M6_hole, h = 16, center=true);
        }


      }

      
      // Piston movement cut
      translate([0, 0, (sc_h1-sc_h2)/2 - sr_wall]){
        cube(size=[sc_d3+10, 20, sc_h2], center=true);
      }
      
      // Top syringe cut
      translate([0, 0, (s_h2-sc_h1)/2 + s_h1 + sc_wall*2]){
        cylinder(d=s_d1, h = s_h2 + sc_wall*2, center=true);
        translate([mh_shift/2, 0, 0]){
//          cube(size=[-mh_shift, s_d3, s_h2], center=true);
        }
      }      
      // Bottom syringe cut
      translate([0, 0, (s_h1 - sc_h1)/2 + sc_wall + 0.1]){
        cylinder(d=s_d1, h = s_h1+10, center=true);
      }      
      // Syringe tip cut
      translate([s_tip_shift, 0, (sc_wall - sc_h1)/2]){
        cylinder(d=s_d2, h = sc_wall*1.1, center=true);
      }      
      
      
      
    }
  }
  
}



module syringe_cartridge_20ml(){
  // Syringe dimensions
  s_d1 = 22.5; // Diameter main cylinder
  s_d2 = 6.5;  // Diameter syringe tip
  s_d3 = 30; // Max diameter
  s_d4 = 17; // Top plate piston
  s_tip_shift = 6;
  s_h1 = 87; // Height main cylinder
  s_h2 = 105; // Height of pulled out piston

  // Threaded rod mount dimensions
  sr_X = 40;
  sr_w = 15;
  sr_wall = 10;
  
  // Syringe cartridge dimensions
  sc_wall = 2;
  sc_d3 = s_d3 + 2 * sc_wall;
  sc_h1 = s_h1 + s_h2 + 2 * sc_wall + 7;
  sc_h2 = 108; // Piston hub cut
  sc_thread_gap = 30;
  
  // Mount halfes
  mh_shift = syringe_cut_shift;
  mh_h = 10;
  mh_w1 = 40;
  mh_w2 = 30;
  mh_w3 = 10;
  mh_wall = 2;
  mh_l1 = sc_d3 + 15+10;
  mh_l2 = mh_l1 - 2 * mh_wall;
  mh_Z1 = 40;
  mh_Z_plus = 80;
  
  translate([0, 0, sc_h1/2]){
    difference(){
      union(){
        cylinder(d=sc_d3, h = sc_h1, center=true);
        translate([0, 0, (cm_wall-sc_h1)/2 + cm_Z1]){
          hull(){
            cylinder(d=sc_d3, h = cm_wall, center=true);
//            translate([sr_X, 0, 0]){
//              cylinder(d=sr_w, h = sr_wall, center=true);
//            }
            translate([sr_X + cm_X1, cm_Y1, 0]){
              cylinder(d=9, h = cm_wall, center=true);
            }
            translate([sr_X + cm_X2, cm_Y2, 0]){
              cylinder(d=9, h = cm_wall, center=true);
            }
          }
        }
        translate([0, 0, cm_Z3 - sc_h1/2]){
          hull(){
            translate([0, 0, 0]){
              cylinder(d=sc_d3, h = cm_wall, center=true);
            }
            translate([sr_X, 0, 0]){
              cylinder(d=bb6_do+4, h = cm_wall, center=true);
            }
            translate([sr_X + cm_X3, cm_Y3, 0]){
              cylinder(d=sr_w, h = cm_wall, center=true);
            }
            translate([sr_X + cm_X4, cm_Y4, 0]){
              cylinder(d=sr_w, h = cm_wall, center=true);
            }
          }
        }
        translate([0, 0, (-sr_wall/2-sc_h1)/2 + sc_h1]){
          hull(){
            cylinder(d=37, h = sr_wall, center=true);
            translate([sr_X, 0, 0]){
              cylinder(d=bb6_do+4, h = cm_wall, center=true);
            }
            translate([sr_X, sc_thread_gap/2, 0]){
              cylinder(d=sr_w, h = sr_wall, center=true);
            }
            translate([sr_X, -sc_thread_gap/2, 0]){
              cylinder(d=sr_w, h = sr_wall, center=true);
            }
          }
        }
        translate([sr_X/2, sc_thread_gap/2, sc_h1/2 - (sc_h1-cm_Z3)/2]){
          cube(size=[sr_X+8, sc_wall, (sc_h1-cm_Z3)], center=true);
        }
        translate([sr_X/2, -sc_thread_gap/2, sc_h1/2 - (sc_h1-cm_Z3)/2]){
          cube(size=[sr_X+8, sc_wall, (sc_h1-cm_Z3)], center=true);
        }
        // Mount points halfes
        for(j=[0:1:1]){
          translate([mh_shift, 0, mh_Z1 - sc_h1/2 + j * mh_Z_plus]){
            difference(){
              hull(){
                translate([0, mh_l1/2, 0])rotate([0, 90, 0]){
                  cylinder(d=mh_h, h = mh_h, center=true);
                }
                translate([0, -mh_l1/2, 0])rotate([0, 90, 0]){
                  cylinder(d=mh_h, h = mh_h, center=true);
                }
//                cube(size=[mh_h, mh_l1, 10], center=true);
              }
              for(i=[0:1:1])mirror([0,i,0])
              translate([0, mh_l1/2, 0])rotate([0, 90, 0]){
                cylinder(d=3, h=mh_l1, center=true);
                translate([0, 0, mh_h/2]){
                  cylinder(d=M3_nut_e, h=5, center=true, $fn=6);
                }
                translate([0, 0, -mh_h/2]){
                  cylinder(d=6, h=6, center=true);
                }
              }
            }
//            for(i=[0:1:1])mirror([0,i,0]){
//              translate([0, (mh_l1+mh_wall)/2, 0]){
//                hull(){
//                  cube(size=[mh_w2, mh_wall, mh_h], center=true);
//                  translate([0, 0, mh_h/2 - 0.5]){
//                    cube(size=[mh_w1, mh_wall*3, 1], center=true);
//                  }
//                }
//              }
//            }
          }
        }
        translate([0, 0, mh_Z1 + mh_Z_plus - (sc_h1 - mh_h - sc_wall)/2]){
          hull(){
            cylinder(d=sc_d3, h=sc_wall, center=true);
            translate([-12, 0, 0]){
              cylinder(d=sc_d3, h=sc_wall, center=true);
            }
          }
        }
      }
      
      // Cartridge mount points
      translate([sr_X + cm_X1, 0, 0]){
//        cylinder(d=sr_w, h = sr_wall, center=true);
      }

      translate([sr_X + cm_X1, cm_Y1, cm_Z1 - sc_h1/2]){
        hull(){
          cylinder(d=5, h = 0.1, center=true);
          translate([0, 0, cm_wall*0.75]){
            cylinder(d=M3_hole, h = 0.1, center=true);
          }
        }
        translate([0, 0, cm_wall/2]){
          cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
        }
      }

      translate([sr_X + cm_X2, cm_Y2, cm_Z2 - sc_h1/2]){
        hull(){
          cylinder(d=5, h = 0.1, center=true);
          translate([0, 0, cm_wall*0.75]){
            cylinder(d=M3_hole, h = 0.1, center=true);
          }
        }
        translate([0, 0, cm_wall/2]){
          cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
        }
      }

      translate([sr_X + cm_X3, cm_Y3, cm_Z3 - (sc_h1 + cm_wall)/2]){
        hull(){
          cylinder(d=5, h = 0.1, center=true);
          translate([0, 0, cm_wall*0.75]){
            cylinder(d=M3_hole, h = 0.1, center=true);
          }
        }
        translate([0, 0, cm_wall/2]){
          cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
        }
      }

      translate([sr_X + cm_X4, cm_Y4, cm_Z4 - (sc_h1 + cm_wall)/2]){
        hull(){
          cylinder(d=5, h = 0.1, center=true);
          translate([0, 0, cm_wall*0.75]){
            cylinder(d=M3_hole, h = 0.1, center=true);
          }
        }
        translate([0, 0, cm_wall/2]){
          cylinder(d=M3_hole, h = cm_wall*1.1, center=true);
        }
      }

      
      // Piston movement cut
      translate([0, 0, (sc_h1-sc_h2)/2 - sr_wall/2]){
        cube(size=[sc_d3+10, 10, sc_h2], center=true);
      }
      
      // Top syringe cut
      translate([0, 0, (s_h2-sc_h1)/2 + s_h1 + sc_wall*2]){
        cylinder(d=s_d3, h = s_h2 + sc_wall*2, center=true);
        translate([mh_shift/2, 0, 0]){
//          cube(size=[-mh_shift, s_d3, s_h2], center=true);
        }
      }      
      // Bottom syringe cut
      translate([0, 0, (s_h1 - sc_h1)/2 + sc_wall + 0.1]){
        cylinder(d=s_d1, h = s_h1, center=true);
        translate([mh_shift/2, 0, 0]){
          cube(size=[-mh_shift, s_d1, s_h1], center=true);
        }
      }      
      // Syringe tip cut
      translate([s_tip_shift, 0, (sc_wall - sc_h1)/2]){
        cylinder(d=s_d2, h = sc_wall*1.1, center=true);
      }      
      
      
      // Threaded rod cut
      translate([sr_X, 0, 0]){
        cylinder(d=bb6_do-6, h = 80, center=true);
      }      
      translate([sr_X, 0, 100]){
        cylinder(d=M6_hole, h = 80, center=true);
      }      
      
      // Bottom ball bearing
//      translate([sr_X, 0, sr_wall-(bb6_h + sc_h1)/2 + 0.1]){
//        cylinder(d=bb6_do, h = bb6_h, center=true);
//      }
      // Bottom ball bearing
      translate([sr_X, 0, cm_Z3 - (sc_h1 + cm_wall - bb6_h)/2 - 0.1]){
        cylinder(d=bb6_do, h = bb6_h, center=true);
      }
      // Middle ball bearing
      translate([sr_X, 0, cm_Z3 - (bb6_h + sc_h1 - cm_wall)/2 + 0.1]){
//        cylinder(d=bb6_do, h = bb6_h, center=true);
      }
      // Top ball bearing
      translate([sr_X, 0, sc_h1/2]){
        cylinder(d=bb6_do, h = 6, center=true);
      }

      // Top gear mount hole
      translate([0, 0, sc_h1/2]){
        cylinder(d=M6_hole, h = 16, center=true);
      }
      
    }
  }
  
}

module gear(teeth = 10,h = 5, shaft=M3_hole, extrude_scale=1){
  mod = 3;
  alpha = 180/teeth;
  r1 = mod*teeth/(2*3.14159);
  r=(mod/2)/tan(alpha);
  
  difference(){
    linear_extrude(height=h, scale=[extrude_scale, extrude_scale]){
      for(i=[0:1:teeth]){
        rotate([0, 0, i*360/teeth]){
          x1=r;
          y1=mod/2;
          x2=r+mod;
          y2=0;
          x3=r;
          y3=-mod/2;
          x4=0;
          y4=0;
          polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
        }
      }
    }
    translate([0, 0, h/2]){
      cylinder(d=shaft, h=h*1.1, center=true);
    }
    if(shaft==-1){
      translate([0, 0, h/2]){
        difference(){
          cylinder(d=motor_shaft, h=h*1.1, center=true);
          translate([0, motor_shaft_shift, 0]){
            cube(size=[motor_shaft, motor_shaft, 16], center=true);
          }
        }
      }
    }
  }
  
}

module cap(){
  tube_d = 48;
  cap_d = tube_d + 8.5;
  cap_h = 20;
  cap_wall = 3;
  tube_wall = 2;
      
  translate([0, 0, cap_h/2]){
    difference(){
      hull(){
        translate([0, 0, tube_wall]){
          cylinder(d=cap_d, h = cap_h-tube_wall, center = true);
        }
        
        translate([0, 0, (tube_wall-cap_h)/2]){
          cylinder(d=cap_d-2, h = tube_wall, center = true);
        }        
      }
      translate([0, 0, cap_wall]){
        cylinder(d=tube_d + tolerance, h = cap_h, center = true);
      }
      // Syringe tip
      translate([0, 0, (cap_wall-cap_h)/2]){
        cylinder(d = 10, cap_wall * 1.1, center=true);
      }
      // Threat cut
      translate([0, 0, -cap_h / 2]){
        difference(){
          helix_extrude(angle=360*thread_no2, height=thread_h2) {
            translate([tube_d/2 - thread_d * 0.2 + tolerance, 0, 0]) {
                circle(d=3);
            }
          }
          translate([0, 0, -cap_h/2*0]){
            cylinder(d=cap_d * 2, h = cap_wall*2, center=true);
          }
        }
      }
    }
  }
}


module roundedRect(size, radius, edges=[1, 1, 1, 1], vscale=[1,1], shift=0){
  x = size[0];
  y = size[1];
  z = size[2];

  translate([0, -shift*2, 0]){
    linear_extrude(height=z, scale=[vscale[0], vscale[1]]){
      translate([0, shift*2, 0]){
        hull(){
            // place 4 circles in the corners, with the given radius
            if(edges[0]){
              translate([(-x/2)+(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
            if(edges[1]){
              translate([(x/2)-(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[2]){
              translate([(-x/2)+(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[3]){
              translate([(x/2)-(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
          }
       }
    }
  }
}

/*
 * =====================================
 *   This is public Domain Code
 *   Contributed by: Gael Lafond
 *   24 March 2017
 * =====================================
 *
 * This is my attempt at creating a predictable
 * helix that can be created from any polygon.
 *
 * It works in a very similar fashion to rotate_extrude,
 * with a height parameter.
 *
 * The height of the final object is equal to the
 * height parameter + the height of the provided polygon.
 */

module helix_extrude(angle=360, height=100) {
	precision = $fn ? $fn : 24;

	// Thickness of polygon used to create an helix segment
	epsilon = 0.001;

	// Number of segments to create.
	//   I reversed ingenering rotate_extrude
	//   to provide a very similar behaviour.
	nbSegments = floor(abs(angle * precision / 360));

	module helix_segment() {
		// The segment is "render" (cached) to save (a lot of) CPU cycles.
		render() {
			// NOTE: hull() doesn't work on 2D polygon in a 3D space.
			//   The polygon needs to be extrude into a 3D shape
			//   before performing the hull() operation.
			//   To work around that problem, we create extremely
			//   thin shape (using linear_extrude) which represent
			//   our 2D polygon.
			hull() {
				rotate([90, 0, 0])
					linear_extrude(height=epsilon) children();

				translate([0, 0, height / nbSegments])
					rotate([90, 0, angle / nbSegments])
						linear_extrude(height=epsilon) children();
			}
		}
	}

	union() {
		for (a = [0:nbSegments-1])
			translate([0, 0, height / nbSegments * a])
				rotate([0, 0, angle / nbSegments * a])
					helix_segment() children();
	}
}
